﻿# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
import urllib, urllib2, urlparse
from xml.dom.minidom import parseString
import json
import re
import time
import random
import os
import tempfile

def httpget(url):
	try:
		file = urllib2.urlopen(url, timeout = 3)
		content = file.read()
		file.close()
		return content
	except:
		print url
		print 'captured'
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urllib.urlencode({'url': url}), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

def getletv(url):
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误201')
		return
	m = re.findall('<div.+?data-tabct="j-tab[1-9]+_child".+?statectn="n_list[1-9]+">(.+?)</div>', content, re.DOTALL)
	for e in m:
		#print e
		m1 = re.findall('<dl class="w120">(.+?)</dl>', e, re.DOTALL)
		for e1 in m1:
			#print e1
			m2 = re.search('<p class="p1">.+?href="(.+?)"[\s]*title="(.+?)".+?>(.+?)</a>', e1, re.DOTALL)
			item(m2.group(2), m2.group(1))
	xbmcplugin.endOfDirectory(handle)

def playletv(url):
	def calcTimeKey(t):
		ror = lambda val, r_bits, : ((val & (2 ** 32 - 1)) >> r_bits % 32) | (val << (32 - (r_bits % 32)) & (2 ** 32 - 1))
		return ror(ror(t, 773625421 % 13) ^ 773625421, 773625421 % 17)

	id = re.search(r'/vplay/(.+?)\.html', url)
	id = id.group(1)
	if id == None:
		xbmcgui.Dialog().ok('错误', '错误301')
		return
	url = 'http://api.letv.com/mms/out/video/playJson?id=' + id + '&platid=1&splatid=101&format=1&tkey=' + str(calcTimeKey(int(time.time()))) + '&domain=www.letv.com'
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误302')
		return
	try:
		data = json.loads(content)
	except:
		xbmcgui.Dialog().ok('错误', '错误303')
		return
	for dispatch in data['playurl']['dispatch']:
		url = data['playurl']['domain'][0]
		url += data['playurl']['dispatch'][dispatch][0]
		url += '&ctv=pc&m3v=1&termid=1&format=1&hwtype=un&ostype=Windows8.1&tag=letv&sign=letv&expect=3'
		#url += '&ctv=pc&m3v=1&termid=1&format=2&hwtype=un&ostype=Windows8.1&tag=letv&sign=letv&expect=3'
		#url += '&ctv=pc&m3v=1&termid=1&format=1&hwtype=un&ostype=Linux&tag=letv&sign=letv&expect=3&tn=' + str(random.random()) + '&pay=0&iscpn=f9051&rateid=' + dispatch
		item(dispatch, url, False)
	xbmcplugin.endOfDirectory(handle)

def playletv2(url):
	def decode(data):
		version = data[0:5]
		if version.lower() == b'vc_01':
			#get real m3u8
			loc2 = data[5:]
			length = len(loc2)
			loc4 = [0] * (2 * length)
			for i in range(length):
				loc4[2 * i] = ord(loc2[i]) >> 4
				loc4[2 * i + 1] = ord(loc2[i]) & 15;
			loc6 = loc4[len(loc4) - 11:] + loc4[:len(loc4) - 11]
			loc7 = [0] * length
			for i in range(length):
				loc7[i] = (loc6[2 * i] << 4) + loc6[2 * i + 1]
			return ''.join([chr(i) for i in loc7])
		else:
			# directly return
			return data

	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误401')
		return
	try:
		data = json.loads(content)
	except:
		xbmcgui.Dialog().ok('错误', '错误402')
		return
	url = data['location']
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误403')
		return
	tmpfd, tempfilename = tempfile.mkstemp()
	m3u8 = open(tempfilename, 'w')
	m3u8.write(decode(content))
	m3u8.close()
	play('', tempfilename)
	#os.close(tmpfd)
	#os.unlink(tempfilename)

# https://github.com/taxigps/xbmc-addons-chinese/blob/master/plugin.video.letv/default.py
# https://github.com/soimort/you-get/blob/develop/src/you_get/extractors/letv.py
handle = int(sys.argv[1])
if sys.argv[2] == '':
	url = 'http://ims.tian-le.com/letv.php'
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误000')
		sys.exit(0)
	dom = parseString(content)
	for element in dom.getElementsByTagName('item'):
		title = element.getElementsByTagName('title')[0].firstChild.nodeValue
		url = element.getElementsByTagName('url')[0].firstChild.nodeValue
		if re.match(r'http://www\.letv\.com/tv/.*\.html', url):
			item(title, url)
		elif re.match(r'http://www\.letv\.com/ptv/vplay/.*\.html', url):
			item(title, url)
	xbmcplugin.endOfDirectory(handle)
else:
	url = urlparse.parse_qs(urlparse.urlparse(sys.argv[2]).query)['url'][0]
	if re.match(r'http://www\.letv\.com/tv/.*\.html', url):
		getletv(url)
	elif re.match(r'http://www\.letv\.com/ptv/vplay/.*\.html', url):
		playletv(url)
	elif re.match(r'http://.*\.lecloud\.com/.*', url):
		playletv2(url)
	else:
		xbmcgui.Dialog().ok('错误', '错误000')
